/* -*- mode: js2; js2-basic-offset: 4; indent-tabs-mode: nil -*- */
/*

    Copyright (C) 2012-2014  Dieter Schärf <ds@dschaerf.de>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program. If not, see <http://www.gnu.org/licenses/>.

 */

const Lang = imports.lang;

const ExtensionUtils = imports.misc.extensionUtils;

const Extension = ExtensionUtils.getCurrentExtension();

const Convenience = Extension.imports.convenience;

/*
    PanelManager
 */
const PanelManager = new Lang.Class({
    Name: 'PanelManager',

    _init: function() {
        this._showDesktop = Extension.imports.showDesktop.getExtension();
        this._favorites = Extension.imports.favorites.getExtension();
        this._places = Extension.imports.places.getExtension();
        this._applications = Extension.imports.applications.getExtension();
        this._notifications = Extension.imports.notifications.getExtension();
        this._recycleBin = Extension.imports.recycleBin.getExtension();
        this._basicSettings = Extension.imports.basicSettings.getExtension();
        this._communications = Extension.imports.communications.getExtension();
        this._accessibility = Extension.imports.accessibility.getExtension();
        this._keyboard = Extension.imports.keyboard.getExtension();
        this._volume = Extension.imports.volume.getExtension();
        this._bluetooth = Extension.imports.bluetooth.getExtension();
        this._network = Extension.imports.network.getExtension();
        this._battery = Extension.imports.battery.getExtension();
        this._userMenu = Extension.imports.userMenu.getExtension();
        this._aggregateMenu = Extension.imports.aggregateMenu.getExtension();
        this._activities = Extension.imports.activities.getExtension();
        this._hotCorners = Extension.imports.hotCorners.getExtension();
        this._dateMenu = Extension.imports.dateMenu.getExtension();
        this._dash = Extension.imports.dash.getExtension();
        this._messageTrayAppTitle = Extension.imports.messageTrayAppTitle.getExtension();
        this._dropDownArrow = Extension.imports.dropDownArrow.getExtension();
    },

    destroy: function() {
        if (this._dropDownArrow) this._dropDownArrow.destroy();
        if (this._messageTrayAppTitle) this._messageTrayAppTitle.destroy();
        this._dash.destroy();
        this._dateMenu.destroy();
        this._hotCorners.destroy();
        this._activities.destroy();
        if (this._aggregateMenu) this._aggregateMenu.destroy();
        if (this._userMenu) this._userMenu.destroy();
        if (this._battery) this._battery.destroy();
        if (this._network) this._network.destroy();
        if (this._bluetooth) this._bluetooth.destroy();
        if (this._volume) this._volume.destroy();
        this._keyboard.destroy();
        if (this._accessibility) this._accessibility.destroy();
        if (this._communications) this._communications.destroy();
        this._basicSettings.destroy();
        this._recycleBin.destroy();
        this._notifications.destroy();
        this._applications.destroy();
        this._places.destroy();
        this._favorites.destroy();
        this._showDesktop.destroy();
    }
});

function getExtension() {
    return new PanelManager();
}
